/*-----------------------------------------------------------------------------------------------*\
\*-----------------------------------------------------------------------------------------------*/
#include <linux/config.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/init.h>
#include <asm/fcntl.h>
#include <asm/ioctl.h>
#include <asm/errno.h>
#include <asm/uaccess.h>
#include <linux/wait.h>
#include <linux/poll.h>
#include <linux/ar7wdt.h>
#include <linux/timer.h>
#include <linux/devfs_fs_kernel.h>
#include <linux/fs.h>
#include <asm/semaphore.h>
#include <asm-mips/avalanche/sangam/sangam.h>
#include <asm-mips/avalanche/sangam/sangam_clk_cntl.h>

#define AVM_EVENT_INTERNAL
#include <linux/ar7wdt.h>

#include <linux/avm_event.h>

#include <asm/avalanche/generic/led_config.h>
#include <asm/avalanche/generic/avalanche_misc.h>
#include "led_hal.h"

#if (CONFIG_MIPS_AVALANCHE_LED == 1) || (CONFIG_MIPS_AVALANCHE_LED_MODULE == 1)
#ifndef CONFIG_AVM_LED
#define LOCAL_ENABLE_LED
#endif
#endif

#define MODULE_NAME     "avm"
MODULE_DESCRIPTION("AR7 Watchdog Timer + LED Driver + AVM Central Event distribution");
#define MODULE_VERSION "1.0"
MODULE_LICENSE("\n(C) Copyright 2003, Texas Instruments, Inc\n(C) Copyright 2004, 2005, AVM");



/*------------------------------------------------------------------------------------------*\
\*------------------------------------------------------------------------------------------*/
int ar7wdt_no_reboot = 0;
MODULE_PARM(ar7wdt_no_reboot, "i");
MODULE_PARM_DESC(ar7wdt_no_reboot, "Watchdog no reboot");

int avm_event_enable_push_button = 0;
MODULE_PARM(avm_event_enable_push_button, "i");
MODULE_PARM_DESC(avm_event_enable_push_button, "enable push putton funktionality");

/*------------------------------------------------------------------------------------------*\
\*------------------------------------------------------------------------------------------*/
int __init avm_sammel_init(void) {
    int ret;
#if (CONFIG_AR7WDT == 1) || (CONFIG_AR7WDT_MODULE == 1)
    ret = ar7wdt_init();
    if(ret) {
        printk("[avm]: ar7wdt_init: failed\n");
        return ret;
    }
#endif /*--- #if (CONFIG_AR7WDT == 1) || (CONFIG_AR7WDT_MODULE == 1) ---*/
#ifdef LOCAL_ENABLE_LED
    ret = led_init();
    if(ret) {
        printk("[avm]: led_init: failed\n");
        return ret;
    }
#endif /*--- #ifdef LOCAL_ENABLE_LED ---*/
#if (CONFIG_AVM_EVENT == 1) || (CONFIG_AVM_EVENT_MODULE == 1)
    ret = avm_event_init();
    if(ret) {
        printk("[avm]: avm_event_init: failed\n");
        return ret;
    }
#endif /*--- #if (CONFIG_AVM_EVENT == 1) || (CONFIG_AVM_EVENT_MODULE == 1) ---*/
    return 0;
}

/*------------------------------------------------------------------------------------------*\
\*------------------------------------------------------------------------------------------*/
module_init(avm_sammel_init);


/*------------------------------------------------------------------------------------------*\
\*------------------------------------------------------------------------------------------*/
int avm_sammel_deinit(void) {
#if (CONFIG_AR7WDT == 1) || (CONFIG_AR7WDT_MODULE == 1)
    ar7wdt_cleanup();
#endif /*--- #if (CONFIG_AR7WDT == 1) || (CONFIG_AR7WDT_MODULE == 1) ---*/
#ifdef LOCAL_ENABLE_LED
    led_exit();
#endif /*--- #ifdef LOCAL_ENABLE_LED ---*/
#if (CONFIG_AVM_EVENT == 1) || (CONFIG_AVM_EVENT_MODULE == 1)
    avm_event_cleanup();
#endif /*--- #if (CONFIG_AVM_EVENT == 1) || (CONFIG_AVM_EVENT_MODULE == 1) ---*/
    return 0;
}

/*------------------------------------------------------------------------------------------*\
\*------------------------------------------------------------------------------------------*/
module_exit(avm_sammel_deinit);
