#ifndef _avm_profile_h_
#define _avm_profile_h_

#if defined(CONFIG_MIPS_OHIO_SIMPLE_PROFILING) && (CONFIG_MIPS_OHIO_SIMPLE_PROFILING > 0)

struct _avm_profile_data {
    unsigned int addr;  /* obersten 3 bit geben die quelle an */
#define KERNEL_PERFOMANCE_USR_TRACE         0x00000000
#define KERNEL_PERFOMANCE_TRACE_SHARE       0x20000000
#define KERNEL_PERFOMANCE_TRACE_SKB         0x40000000
    /* pos maximal 4 Bit */
#define KERNEL_PERFOMANCE_TRACE_SKB_ID(pos) (KERNEL_PERFOMANCE_TRACE_SKB | (pos << (29 - 6)))
#define KERNEL_PERFOMANCE_TRACE_RESERVED1   0x60000000
#define KERNEL_PERFOMANCE_TRACE_KERNEL      0x80000000
#define KERNEL_PERFOMANCE_TRACE_VM          0xC0000000
#define KERNEL_PERFOMANCE_TRACE_RESERVED2   0xA0000000
#define KERNEL_PERFOMANCE_TRACE_RESERVED3   0xE0000000
    unsigned int time;
};

void ohio_simple_profiling_text(const  char *text);
void ohio_simple_profiling_log(unsigned int addr, unsigned int id);
void ohio_simple_profiling(struct pt_regs *regs);
struct _avm_profile_data *ohio_simple_profiling_enable(unsigned int on, unsigned int *count);

#else /*--- #if defined(CONFIG_MIPS_OHIO_SIMPLE_PROFILING) && (CONFIG_MIPS_OHIO_SIMPLE_PROFILING > 0) ---*/
#define ohio_simple_profiling_text(text)
#define ohio_simple_profiling_log(addr, id)
#define ohio_simple_profiling(regs)
#define ohio_simple_profiling_enable(on, count)     NULL;
#endif /*--- #else ---*/ /*--- #if defined(CONFIG_MIPS_OHIO_SIMPLE_PROFILING) && (CONFIG_MIPS_OHIO_SIMPLE_PROFILING > 0) ---*/

#endif /*--- #ifndef _avm_profile_h_ ---*/
