/*------------------------------------------------------------------------------------------*\
 *   
 *   Copyright (C) 2006 AVM GmbH <fritzbox_info@avm.de>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
\*------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------*\
\*------------------------------------------------------------------------------------------*/
#ifndef _AVM_POWER_H_
#define _AVM_POWER_H_

/*--- #define AVM_POWER_DEBUG ---*/

#if defined(AVM_POWER_DEBUG)
#define DEB_ERR(args...)     printk(KERN_ERR args)
#define DEB_WARN(args...)    printk(KERN_WARNING args)
#define DEB_NOTE(args...)    printk(KERN_NOTICE args)
#define DEB_INFO(args...)    printk(KERN_INFO args)
#define DEB_TRACE(args...)   printk(KERN_INFO args)
#else /*--- #if defined(AVM_POWER_DEBUG) ---*/
#define DEB_ERR(args...)     printk(KERN_ERR args)
#define DEB_WARN(args...)    printk(KERN_WARNING args)   
#define DEB_NOTE(args...)
#define DEB_INFO(args...)
#define DEB_TRACE(args...)
#endif /*--- #else ---*/ /*--- #if defined(AVM_POWER_DEBUG) ---*/

/*------------------------------------------------------------------------------------------*\
\*------------------------------------------------------------------------------------------*/
#include <asm/atomic.h>

/*------------------------------------------------------------------------------------------*\
\*------------------------------------------------------------------------------------------*/
struct _avm_power {
    dev_t         device;
    struct cdev  *cdev;
    void         *event_handle;
};
extern struct _avm_power avm_power;

/*------------------------------------------------------------------------------------------*\
\*------------------------------------------------------------------------------------------*/
struct _avm_power_open_data {
    unsigned int reserved;
};

/*-------------------------------------------------------------------------------------*\
 * Eintrag in _power_managment
\*-------------------------------------------------------------------------------------*/
struct _power_managment_dest_entry {
    char *client_name;  /*--- (registrierter) client-name ---*/
    int  mandatory;     /*--- 1: falls Aktion scheitert(return-Wert von CallBackPowerManagmentControl): Tabelle nicht weiter abarbeiten ---*/
    int  state;         /*--- bergabeparameter der fuer CallBackPowerManagmentControl ---*/
};

/*------------------------------------------------------------------------------------------*\
 * powermode fhrt folgende Tabelle (d.h. CallBackPowerManagmentControl() aus)
\*------------------------------------------------------------------------------------------*/
struct _power_managment {
    char *powermode;
    struct _power_managment_dest_entry *dests;
};

/*-------------------------------------------------------------------------------------*\
 * sammelt PowerManagmentRegister
\*-------------------------------------------------------------------------------------*/
struct _power_managment_clients {
    struct _power_managment_clients *next;
    char *client_name;
    int (*CallBackPowerManagmentControl)(int state);
};

#endif /*--- #ifndef _AVM_POWER_H_ ---*/
