/******************************************************************************
 * FILE PURPOSE:    ESWITCH Driver support Header file
 ******************************************************************************
 * FILE NAME:       eswitchConfig.h
 *
 * DESCRIPTION:     ESWITCH Configuration structure for PUSH mechanism
 * 
 * REVISION HISTORY:
 *   19th NOV. 03 - PSP TII  
 *    8th Dec. 03 - PSP TII  

 *
 * (C) Copyright 2003, Texas Instruments, Inc
 *******************************************************************************/

#ifndef _ESWITCH_CONFIG_H_
#define _ESWITCH_CONFIG_H_
#include "avalanche_map.h"
typedef struct eswitch_config
{ 
  unsigned int CpuFrequency;  
  unsigned int EswitchFrequency;
  unsigned int ResetBase;
  unsigned int EswitchResetBit;
  unsigned int Cpmac0ResetBit;
  unsigned int Cpmac1ResetBit;
  unsigned int MdioResetBit;
  unsigned int Phy0ResetBit;
  unsigned int Phy1ResetBit;
  unsigned int HdmaResetBit;
  unsigned int IntBase;
  unsigned int Cpmac0IntBit;
  unsigned int Cpmac1IntBit;
  unsigned int EswitchIntBit;
  unsigned int EswitchBase;
  unsigned int EswitchBufferSize;
  unsigned int EswitchHostBufCount;
  unsigned int EswitchDefaultCamSize;
  unsigned int EswitchOverFlowCount;
  unsigned int EswitchOverFlowSize;
  unsigned int EswitchSize;
}ESWITCH_CONFIG;

#include "eswitchHalLx.h" /* The functions declared in this header file requires definition for ESWITCH_CONFIG structure*/ 
void get_eswitch_config_info(ESWITCH_CONFIG **p_eswitch_config);
int eswitchConfig(HAL_DEVICE *HalDev, HAL_FUNCTIONS *HalFunc, ESWITCH_CONFIG *Config);

#endif
