/******************************************************************************
 * FILE PURPOSE:    ESWITCH Driver support Header file
 ******************************************************************************
 * FILE NAME:       eswitchHalLx.h
 *
 * DESCRIPTION:     eswitch OS - HAL header prototype
 * 
 * REVISION HISTORY:
 *   19th NOV. 03 - PSP TII  
 *    8th Dec. 03 - PSP TII  

 *
 * (C) Copyright 2003, Texas Instruments, Inc
 *******************************************************************************/

#ifndef __ESWITCH_HAL_LX_H
#define __ESWITCH_HAL_LX_H

typedef struct net_device         OS_DEVICE;
typedef struct sk_buff            OS_RECEIVEINFO;
typedef struct sk_buff            OS_SENDINFO;

#define OS_SETUP   void

#include "cpswhal.h"
#include "cpswhaleswitch.h"
#include "eswitch.h"
int eswitch_drv_start(ESWITCH_PRIVATE_INFO_T *p_eswitch_priv,
                      ESWITCH_TX_CHAN_INFO_T *p_tx_chan_info,
                      ESWITCH_RX_CHAN_INFO_T *p_rx_chan_info,		      
            	      unsigned int           flags);

int eswitch_drv_cleanup (ESWITCH_DRV_HAL_INFO_T *);
int eswitch_drv_init (ESWITCH_DRV_HAL_INFO_T*);
int eswitch_drv_close (ESWITCH_DRV_HAL_INFO_T*);
int eswitch_drv_open (ESWITCH_DRV_HAL_INFO_T*);
int eswitch_drv_init_module (ESWITCH_DRV_HAL_INFO_T*, OS_DEVICE*, int);
int eswitch_drv_stop (ESWITCH_DRV_HAL_INFO_T *p_drv_hal,
		      ESWITCH_TX_CHAN_INFO_T *p_tx_chan_info,
                      ESWITCH_RX_CHAN_INFO_T *p_rx_chan_info,
		      unsigned int flags);

#endif
