
#define SNWAY_LPBK           (1<<9)
#define SNWAY_FD100          (1<<8)
#define SNWAY_HD100          (1<<7)
#define SNWAY_FD10           (1<<6)
#define SNWAY_HD10           (1<<5)
#define SNWAY_AUTO           (1<<0)

typedef enum
  {
   BLOCK=0, LEARN, LEARN_FWD
  }STP_STATE;

#define STP_SUPPORT  (1<<29)
#define GVRP_SUPPORT (1<<30)
#define GMRP_SUPPORT (1<<31)

#define ESWITCH_NOERROR       (0)
#define ESWITCH_HWTIMEOUT     (1)
#define ESWITCH_INVALIDPORT   (2)
#define ESWITCH_INVALIDVLANID (3)
#define ESWITCH_NOTFOUND      (4)
#define ESWITCH_NOSPACE       (5)
#define ESWITCH_INVALIDPARM   (6)

#define ESWITCH_PORT_LINK    (1<<7)
#define ESWITCH_PORT_SPEED   (1<<6)
#define ESWITCH_PORT_DUPLEX  (1<<5)
#define ESWITCH_PORT_PHYNUM  (0x1f<<0)

int  cpswHalEswitchInitModule(HAL_DEVICE **HalDev, OS_DEVICE *OsDev, HAL_FUNCTIONS **HalFunc,
         OS_FUNCTIONS *OsFunc, int OsFuncSize, int *HalFuncSize, int Inst);

typedef struct _hal_functions_ext_s
  {
  int  (*EswitchDisablePort)                (HAL_DEVICE *HalDev,bit32u port);
  int  (*EswitchEnablePort)                 (HAL_DEVICE *HalDev,bit32u port);
  int  (*EswitchEnableMode)                 (HAL_DEVICE *HalDev,bit32u mode);
  int  (*EswitchDisableMode)                (HAL_DEVICE *HalDev,bit32u mode);
  int  (*EswitchCamDump)                    (HAL_DEVICE *HalDev);
  int  (*EswitchCamAddAddress)              (HAL_DEVICE *HalDev,char *addr,bit32u VlanId,bit32u Member);
  int  (*EswitchCamAddVlan)                 (HAL_DEVICE *HalDev,bit32u VlanId,bit32u MemberSet,bit32u FwdAllMulticast,bit32u FwdUnregMulticast,bit32u FwdUntagged);
  int  (*EswitchCamDelAddress)              (HAL_DEVICE *HalDev,char *addr,bit32u VlanId);
  int  (*EswitchCamDelVlan)                 (HAL_DEVICE *HalDev,bit32u VlanId);
  int  (*EswitchCamFindAddress)             (HAL_DEVICE *HalDev,char *addr,bit32u VlanId,bit32u *member);
  int  (*EswitchCamFindVlan)                (HAL_DEVICE *HalDev,bit32u VlanId,bit32u *MemberSet,bit32u *FwdAllMulticast,bit32u *FwdUnregMulticast,bit32u *FwdUntagged);
  int  (*EswitchEnableVIDIngress)           (HAL_DEVICE *HalDev,bit32u Port);
  int  (*EswitchDisableVIDIngress)          (HAL_DEVICE *HalDev,bit32u Port);
  int  (*EswitchEnableDropUnTaggedIngress)  (HAL_DEVICE *HalDev,bit32u Port);
  int  (*EswitchDisableDropUnTaggedIngress) (HAL_DEVICE *HalDev,bit32u Port);
  int  (*EswitchSetPriorityMapping)         (HAL_DEVICE *HalDev, bit32u Port, bit32u InputPriority, bit32u OutputPriority, bit32u OutputChannel);
  int  (*EswitchSetPortVlanId)              (HAL_DEVICE *HalDev, bit32u Port, bit32u VlanId);
  int  (*EswitchStpPortState)               (HAL_DEVICE *HalDev, bit32u Port, STP_STATE State);
  int  (*EswitchSetAgeInterval)             (HAL_DEVICE *HalDev,bit32u count);
  }_hal_functions_ext;

extern const char hcMacAddress[];
extern const char hcEswitchResetBit[];
extern const char hcCpmac0ResetBit[];
extern const char hcCpmac1ResetBit[];
extern const char hcMdioResetBit[];
extern const char hcPhy0ResetBit[];
extern const char hcPhy1ResetBit[];
extern const char hcHdmaResetBit[];
extern const char hcCpmac0IntBit[];
extern const char hcCpmac1IntBit[];
extern const char hcEswitchIntBit[];
extern const char hcEswitchBase[];
extern const char hcEswitchBufferSize[];
extern const char hcEswitchHostBufCount[];
extern const char hcEswitchDefaultCamSize[];
extern const char hcEswitchOverFlowCount[];
extern const char hcEswitchOverFlowSize[];
extern const char hcTxMaxPending[];
extern const char hcRxSSBufSize[];
extern const char hcRxIPBufSize[];
extern const char hcRxSSNumBuffers[];
extern const char hcRxIPNumBuffers[];
extern const char hcMdioPhyMask0[];
extern const char hcMdioPhyMask1[];
extern const char hcMdioPhyMode0[];
extern const char hcMdioPhyMode1[];
extern const char hcEswitchFrequency[];
extern const char hcPhyStatus[];
