/*****************************************************************************
**	TNETD53xx Software Support
**	Copyright(c) 2002, Texas Instruments Incorporated. All Rights Reserved.
**
**	FILE: cpmdio.h   User Include for MDIO API Access
**
** 	DESCRIPTION:
**		This include file contains definitions for the the MDIO API
**
** 	HISTORY:
**		27Mar02 Michael Hanrahan Original (modified from emacmdio.h)
**		04Apr02 Michael Hanrahan Added Interrupt Support
*****************************************************************************/
#ifndef _INC_CPMDIO
#define _INC_CPMDIO

/*Version Information */

void cpswHalUtlMiiMdioGetVer(bit32u miiBase, bit32u *ModID,  bit32u *RevMaj,  bit32u *RevMin);

/*Called once at the begining of time                                        */

int  cpswHalUtlMiiMdioGetPhyDevSize(void);  /*Called first to get size of storage needed!*/

int  cpswHalUtlMiiMdioInit(PHY_DEVICE *PhyDev, bit32u miibase, bit32u inst, bit32u PhyMask, 
                        bit32u MLinkMask, bit32u ResetBase, bit32u ResetBit, bit32u MdioBusFreq,
                        bit32u MdioClockFreq,int verbose,int (*osprintf)(const char *Format, ...));



/*Called every 10 mili Seconds, returns TRUE if there has been a mode change */

int cpswHalUtlMiiMdioTic(PHY_DEVICE *PhyDev);

/*Called to set Phy mode                                                     */

void cpswHalUtlMiiMdioSetPhyMode(PHY_DEVICE *PhyDev,bit32u PhyMode);

/*Calls to retreive info after a mode change!                                */

int  cpswHalUtlMiiMdioGetDuplex(PHY_DEVICE *PhyDev);
int  cpswHalUtlMiiMdioGetSpeed(PHY_DEVICE *PhyDev);
int  cpswHalUtlMiiMdioGetPhyNum(PHY_DEVICE *PhyDev);
int  cpswHalUtlMiiMdioGetLinked(PHY_DEVICE *PhyDev);
void cpswHalUtlMiiMdioLinkChange(PHY_DEVICE *PhyDev);

/*  Shut Down  */

void cpswHalUtlMiiMdioClose(PHY_DEVICE *PhyDev, int Full);


/* Phy Mode Values  */

#define NWAY_LPBK           (1<<9)
#define NWAY_FD100          (1<<8)
#define NWAY_HD100          (1<<7)
#define NWAY_FD10           (1<<6)
#define NWAY_HD10           (1<<5)
#define NWAY_AUTO           (1<<0)

#endif  /*  _INC_CPMDIO */
