
#define _CPSW_HAL

typedef void OS_DEVICE;
typedef void OS_SENDINFO;
typedef void OS_RECEIVEINFO;
typedef void OS_SETUP;

typedef struct hal_device  HAL_DEVICE;
typedef struct hal_private HAL_RECEIVEINFO;
typedef volatile struct hal_private HAL_RCB;

#include "cpswhal.h"
#include "cpswhalutlsupport.h"
#include "cpswhalutlparams.h"

#define SETBIN 0
#define GETBIN 1
#define SETSTR 2
#define GETSTR 3

int cpswHalUtlParamsControl(void *HalDev,OS_FUNCTIONS *OsFunc,const DEVICE_PARAMS *DeviceParams,SUB_STRUCT *SubStruct, const char *Key, int Action, void *Value)
  {
  char keyCopy[40],*p1,*p2,*p3;
  void *stbase;

  if ((Action==SETSTR)||(Action==GETSTR))
    OsFunc->Printf("cpswHal$Control(%08x,\"%s\",%s,\"%s\");\n",(bit32u)HalDev,Key,(Action==SETSTR)?"SETSTR":"GETSTR",(char *)Value);
/*   else                                                                    */
/*    OsFunc->Printf("cpswHal$Control(%08x,\"%s\",%s,%08x);\n",(bit32u)HalDev,Key,(Action==SETBIN)?"SETBIN":"GETBIN",(bit32u)Value);*/

  if ((cpswHalUtlstrcmp("Action",Key)==0)&&(Action==SETSTR)&&(cpswHalUtlstrcmp("halDumpParams",(char*)Value)==0)) {cpswHalUtlParamsDump(HalDev,OsFunc,DeviceParams); return(0);}

  if (cpswHalUtlstrlen(Key)>=(sizeof keyCopy))
    return(1);
  cpswHalUtlstrcpy(keyCopy,Key);
  p1=keyCopy;
  p3=0;
  p2=cpswHalUtlstrchr(p1,'.');
  if(p2) 
    {
    *p2++=0; 
    p3=cpswHalUtlstrchr(p2,'.');
    if(p3) 
      *p3++=0; 
    }
 
  while(DeviceParams->pszKey)
    {
    if (cpswHalUtlstrcmp(DeviceParams->pszKey,p1)==0)
      {
      stbase=HalDev;
/*      switch((DeviceParams->Type&SUB_MASK)>>SUB_SHIFT)                     */
/*        {                                                                  */
/*        case 0: stbase=HalDev; break;                                      */
/*        case 1: stbase=SubStruct[0].sub_struct; break;                     */
/*        case 2: stbase=SubStruct[1].sub_struct; break;                     */
/*        case 3: stbase=SubStruct[2].sub_struct; break;                     */
/*        }                                                                  */

      if ((Action==SETBIN)&&((DeviceParams->Type&ISSTRING)==0))
        {
        if (!( ( DeviceParams->LowValue<=((bit32u)Value) ) &&( DeviceParams->HighValue>=((bit32u)Value) ) ) ) 
          {OsFunc->Printf("Write to %s is out of range!\n",p1); return(3);}
        *((bit32u*)(((bit32u)HalDev)+((bit32u)DeviceParams->Offset)))=(bit32u)Value;
       
/*        FuncAction=DeviceParams->ExtFunc&FUNC_MASK>>FUNC_SHF;              */
/*        if (FuncAction)                                                    */
/*          ExtFunc[FuncAction]();                                           */

        return(0);
        }
      if ((Action==GETBIN)&&((DeviceParams->Type&ISSTRING)==0))
        {
        *((bit32u*)Value)=*((bit32u*)(((bit32u)HalDev)+((bit32u)DeviceParams->Offset)));
        return(0);
        }
      return(2);
      }
    DeviceParams++;
    }
  return(1);
  }

int cpswHalUtlParamsDump(void *HalDev,OS_FUNCTIONS *OsFunc,const DEVICE_PARAMS *DeviceParams)
  {
  int line=0;

  while(DeviceParams->pszKey)
    {
    OsFunc->Printf("%-25s ",DeviceParams->pszKey);
    if (DeviceParams->Type&ISSTRING)
      OsFunc->Printf("%-10s",((char*)(((bit32u)HalDev)+((bit32u)DeviceParams->Offset))));
     else
      OsFunc->Printf("0x%08x",*((bit32u*)(((bit32u)HalDev)+((bit32u)DeviceParams->Offset))));
    if (line++)
      { OsFunc->Printf("\n"); line=0;}
     else
      OsFunc->Printf("    ");
    DeviceParams++;
    }
  if (line)
    OsFunc->Printf("\n");
  return(0);
  }

int cpswHalUtlParamsGetConfig(void *HalDev,OS_FUNCTIONS *OsFunc,const CONFIG_PARAMS *cDeviceParams,const DEVICE_PARAMS *DeviceParams,SUB_STRUCT *SubStructs)
  {
  const char *pkey,*pkeyparm;
  bit32u handle,keyerrorval,sts,more,loops;
  char sectionname[40];

  char KeyCopy[40],*p1,*p2,*p3=0;

  handle=0;
  while(cDeviceParams->key)
    {
    pkey=cDeviceParams->key;
    pkeyparm=cDeviceParams->keyparm;
    keyerrorval=cDeviceParams->errorval;  
    cDeviceParams++;
    if (!pkeyparm)
      {
      if (handle)
        OsFunc->Printf("CloseConfig(%s);\n",sectionname);
      cpswHalUtlstrcpy(sectionname,pkey);
      handle=5;
      OsFunc->Printf("OpenConfig(%s);\n",sectionname);
      }
     else
      {
      if (cpswHalUtlstrlen(pkey)<(sizeof KeyCopy))
        {
        cpswHalUtlstrcpy(KeyCopy,pkey);
        p1=KeyCopy;
        p2=cpswHalUtlstrchr(p1,'.');
        if (p2)
          {
          *p2++=0;
          p3=cpswHalUtlstrchr(p2,'.');
          if(p3) 
            *p3++=0;
          }
        OsFunc->Printf("ReadConfig(%s,%s);\n",sectionname,p1);
        sts=cpswHalUtlParamsControl(HalDev,OsFunc,DeviceParams,SubStructs,pkeyparm,SETSTR,"val");
/*        if ((sts)&&(keyerrorval)) return(keyerrorval);                     */
        if (p2)
          {
          loops=cpswHalUtlstrtoul(p2,0,10);
          more=0;
          if (p3)
            {
            more=cpswHalUtlstrtoul(p3,0,10);
            }
          sts=cpswHalUtlParamsGetConfigArray(HalDev,OsFunc,DeviceParams,SubStructs,sectionname,p1,pkeyparm,loops,keyerrorval,more);
/*        if ((sts)&&(keyerrorval)) return(keyerrorval);                     */
          }
        }
      }
    }
  if (handle)
    OsFunc->Printf("CloseConfig(%s);\n",sectionname);
  return(0);
  }

int cpswHalUtlParamsGetConfigArray(void *HalDev,OS_FUNCTIONS *OsFunc,const DEVICE_PARAMS *DeviceParams,SUB_STRUCT *SubStructs,
                                   char *sectionname,char *pSKey,const char *pWKey,int loops,bit32u err,int more)
  {
  char NewControlKey[40],NewSearchKey[40];
  int i,sts;

  if (loops)
    for(i=0;i<loops;i++)
      {
      cpswHalUtlstrcpy(NewSearchKey,pSKey);
      cpswHalUtlstrcat(NewSearchKey,".");
      cpswHalUtlcatdnum(NewSearchKey,i);
      cpswHalUtlstrcpy(NewControlKey,pWKey);
      cpswHalUtlstrcat(NewControlKey,".");
      cpswHalUtlcatdnum(NewControlKey,i);
      OsFunc->Printf("ReadConfig(%s,%s);\n",sectionname,NewSearchKey);
      sts=cpswHalUtlParamsControl(HalDev,OsFunc,DeviceParams,SubStructs,NewControlKey,SETSTR,"val");
/*      if ((sts)&&(err)) return(err);                                       */
      if (more)
        sts=cpswHalUtlParamsGetConfigArray(HalDev,OsFunc,DeviceParams,SubStructs,sectionname,NewSearchKey,NewControlKey,more,err,0);
/*      if ((sts)&&(err)) return(err);                                       */
      }
  return(0);
  }

int cpswHalUtlParamsCheckAllParams(void *HalDev,OS_FUNCTIONS *OsFunc,const DEVICE_PARAMS *DeviceParams)
  {
  bit32u val,hi,lo;

  while(DeviceParams->pszKey)
    {
    if (DeviceParams->Type&ISSTRING)
      val=cpswHalUtlstrlen(((char*)(((bit32u)HalDev)+((bit32u)DeviceParams->Offset))));
     else
      val=*((bit32u*)(((bit32u)HalDev)+((bit32u)DeviceParams->Offset)));
    hi=DeviceParams->HighValue;
    lo=DeviceParams->LowValue;

    if (!((val>=lo)&&(val<=hi))) 
      {OsFunc->Printf("Check Error: %s Out of range: val=%08x, hi=%08x, lo=%08x\n",DeviceParams->pszKey,val,hi,lo); return(1);}
    DeviceParams++;
    }
  return(0);
  }

int cpswHalUtlParamsInit(void *HalDev,OS_FUNCTIONS *OsFunc,const DEVICE_PARAMS *DeviceParams)
  {

  while(DeviceParams->pszKey)
    {
    if (DeviceParams->Type&DO_INIT)
      {
      if (DeviceParams->Type&ISSTRING)
        {
        if (cpswHalUtlstrlen((char *)DeviceParams->Default)<DeviceParams->HighValue)
          cpswHalUtlstrcpy(((char*)(((bit32u)HalDev)+((bit32u)DeviceParams->Offset))),(char*)DeviceParams->Default);
        }
       else
        *((bit32u*)(((bit32u)HalDev)+((bit32u)DeviceParams->Offset)))=DeviceParams->Default;
      }
    DeviceParams++;
    }
  return(0);
  }

