#include "cpswhalutlsupport.h"

size_t cpswHalUtlstrlen(const char *s)
  {
  int l = 0;

  while (*s++) l++;
  return(l);
  }

char *cpswHalUtlstrcpy(char *s1, const char *s2)
  {
  char *s = s1;

  while((*s1++=*s2++));
  return(s);
  }

char *cpswHalUtlstrchr(const char *s, int	c)
  {
  for (;; ++s) 
    {
    if (*s == c) 
      return((char *) s);
    if (!*s)     
      return((char *) 0);
    }
  }

int cpswHalUtlstrcmp(const char	*s1,const char	*s2)
  {
  while (*s1 || *s2)
    if (*s1++ != *s2++)
      return(*--s1 - *--s2);
  return 0;
  }

void *cpswHalUtlmemset(void *s, int c, size_t n)
  {
  unsigned char *ucp=s,uc=c;

  while(n--)
    *ucp++=uc;
  return(s);
  }

void cpswHalUtlcatdnum(char *s,int num)
  {
  if (num>9) 
    cpswHalUtlcatdnum(s,num/10);
  while(*s) s++;
  num=num%10;
  *s++=num+'0';
  *s=0;
  }

char *cpswHalUtlstrcat(char *s1, const char *s2)
  {
  register char	*s = s1;

  while (*s1) s1++;
  while ((*s1++ = *s2++));
  return s;
  }

unsigned long cpswHalUtlstrtoul(const char *str, char **endptr, int base)
  {
  char *s;
  int neg,c,error,any;
  unsigned int acc;

  s=(char *)str;
  while((*s)&&((*s==' ')||(*s=='\t'))) s++;  /*Skip white space              */
  if (*s=='-')
    {neg=1; s++;}
   else
    {neg=0; if (*s=='+') s++;}
  if (((base==0)||(base==16))&&(*s=='0')&&((s[1]&0x5f)=='X')) 
    {base=16; s+=2;}
  if (base==0)
    base=(*s=='0')?8:10;
  c=*s;
  error=0;
  acc=0;
  any=0;

  while((*s)&&(error==0))
    {
    c=*s;
    if (c>'9') 
      {
      c&=0x5f;
      if ((c<'A')||(c>'F'))
        error++;
      }
     else
      if (c<'0') error++;
    c-='0';
    if (c>9) c-=7;
    if ((c<base)&&(error==0)) 
      {acc*=base; acc+=c; any++;} 
     else
      error++;
    s++;
    }
  s--;
  if (neg) acc = -acc;
  if (any)
    {
    if (endptr) *endptr=s;
    return(acc);
    }
   else
    {
    if (endptr) *endptr=(char *)str;
    return(0);
    }
  }

static bit32u testpat[]={0x55555555,0xaaaaaaaa,0x33333333,0xcccccccc,
                         0x0f0f0f0f,0xf0f0f0f0,0x00ff00ff,0xff00ff00,
                         0x0000ffff,0xffff0000,0x00000000,0xffffffff,
                         0x00000000};

bit32u cpswHalUtlMemBasicDataTest(bit32u base)
  {
  bit32u *sp,exp,fnd,i,error;
  volatile bit32u *dp,*dp2;

  base&=0x1fffffff;
  base|=0xa0000000;
  base&=~3;
  dp=(volatile bit32u *)(base);
  dp2=(volatile bit32u *)(base+4);
  error=0;
  sp=testpat;
  for(i=0;i<(sizeof(testpat)/4);i++,sp++)
    {
    exp=*sp;
    *dp=exp;
    *dp2=i;
    fnd=*dp;
    error|=(exp^fnd);
    }
  return(error);
  }

bit32u cpswHalUtlMemAddressTest(bit32u base,bit32u size)
  {
  bit32u error,i,j,exp,fnd;
  volatile bit32u *dp;

  base&=~3;
  size&=~3;
  if (size<(16*1024))
    {
    base&=0x1fffffff;
    base|=0xa0000000;
    }
  error=0;
  for(i=0,j=base,dp=(volatile bit32u *)base;i<size;i+=4,j+=4,dp++)
    *dp=j;
  for(i=0,j=base,dp=(volatile bit32u *)base;i<size;i+=4,j+=4,dp++)
    {
    fnd=*dp;
    exp=j;
    error|=exp^fnd;
    }
  return(error);
  }

bit32u cpswHalUtlMemDataTest(bit32u base,bit32u size,int verbose)
  {
  bit32u error,exp,fnd,i,j,ci,*sp;
  volatile bit32u *dp;

  base&=~3;
  size&=~3;
  if (size<(16*1024))
    {
    base&=0x1fffffff;
    base|=0xa0000000;
    }
  error=0;
  for(j=0;(j<(sizeof(testpat)/4))&&(error==0)&&((j<2)||(verbose));j++)
    {
    for(i=0,ci=j,sp=&testpat[j],dp=(volatile bit32u *)base;i<size;i+=4,ci++)
      {
      if (ci>=(sizeof(testpat)/4)) 
        { ci=0; sp=testpat; }
      *dp++=*sp++;
      }
    for(i=0,ci=j,sp=&testpat[j],dp=(volatile bit32u *)base;i<size;i+=4,ci++)
      {
      if (ci>=(sizeof(testpat)/4)) 
        {ci=0;sp=testpat;}
      exp=*sp++;
      fnd=*dp++;
      error|=exp^fnd;
      }
    }
  return(error);
  }

const char hcCpuFrequency[]="CpuFrequency";
const char hcResetBase[]="ResetBase";
const char hcdebug[]="debug";
const char hcdev_base[]="dev_base";
const char hcMaxChannel[]="MaxChannel";
const char hcTxServiceMax[]="TxServiceMax";
const char hcRxServiceMax[]="RxServiceMax";
const char hcid[]="id";
const char hcoffset[]="offset";
const char hcInst[]="Inst";
const char hcTick[]="Tick";
const char hcSet[]="Set";
const char hcClear[]="Clear";
const char hcStateChange[]="StateChange";

