/*------------------------------------------------------------------------------------------*\
\*------------------------------------------------------------------------------------------*/
#ifndef _ledcfg_h_
#define _ledcfg_h_

#include <linux/config.h>
#include <linux/version.h>

#if KERNEL_VERSION(2,4,17) == LINUX_VERSION_CODE 
#include <asm/avalanche/generic/led_config.h>
#endif

int ledlib_init(void);
int ledlib_deinit(void);
void *ledlib_open(char *name, int instance);
int ledlib_close(void *handle);
int ledlib_action(void *handle, int new_state);
int ledlib_action_with_event(void *handle, int new_state, unsigned int param_len, void *param);

#ifdef CONFIG_LED_REMAP
int ledlib_unmap_states(char *from_name, int from_instance);
int ledlib_map_states(char *from_name, int from_instance, 
                      char *to_name, int to_instance, 
                      int remapped_only, 
                      unsigned int from_state[CONFIG_LED_REMAP_STATES],
                      unsigned int to_state[CONFIG_LED_REMAP_STATES]);
#endif /*--- #ifdef CONFIG_LED_REMAP ---*/



#endif /*--- #ifndef _ledcfg_h_ ---*/
